package tools.descartes.prisma.core.templates.core;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

import edu.kit.ipd.descartes.core.NamedElement;
import tools.descartes.prisma.core.templates.ModelTemplate;

public abstract class NamedElementTemplate<P extends EObject, E extends NamedElement> extends ModelTemplate<P, E> {

	private final String name;
	
	public NamedElementTemplate(Status status, EStructuralFeature container, Class<E> elementType, String name) {
		super(status, container, elementType);
		this.name = name;
	}
	
	public NamedElementTemplate(EStructuralFeature container, Class<E> elementType, String name) {
		super(container, elementType);
		this.name = name;
	}
	
	public String getName() {
		return name;
	}
	
	@Override
	public boolean matches(E object) {
		if (object != null) {
			return object.getName().equals(name);
		}
		return false;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		NamedElementTemplate<?,?> other = (NamedElementTemplate<?,?>) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}

}
