package tools.descartes.prisma.core.templates.repository;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.Interface;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingEntity;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryFactory;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;
import tools.descartes.prisma.core.templates.core.NamedElementTemplate;

public class InterfaceProvidingRoleTemplate extends NamedElementTemplate<InterfaceProvidingEntity, InterfaceProvidingRole> {
	
	private final InterfaceTemplate interfaceCmd;
	
	public InterfaceProvidingRoleTemplate(String portName, InterfaceTemplate addInterface) {
		this(Status.CREATE, portName, addInterface);
	}

	public InterfaceProvidingRoleTemplate(Status status, String portName, InterfaceTemplate addInterface) {
		super(status, RepositoryPackage.Literals.INTERFACE_PROVIDING_ENTITY__INTERFACE_PROVIDING_ROLES, InterfaceProvidingRole.class, portName);
		this.interfaceCmd = addInterface;
	}

	@Override
	public boolean matches(InterfaceProvidingRole object) {
		if (object != null) {
			return super.matches(object)
					&& interfaceCmd.matches(object.getInterface());
		}
		return false;
	}

	@Override
	protected InterfaceProvidingRole create(InterfaceProvidingEntity parent) {
		Interface interf = interfaceCmd.get(getContext().getRepository());
		InterfaceProvidingRole providingRole = RepositoryFactory.eINSTANCE.createInterfaceProvidingRole();
		providingRole.setName(getName());
		providingRole.setInterface(interf);
		return providingRole;
	}

}
