package tools.descartes.prisma.core.templates.repository;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.Interface;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceRequiringEntity;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceRequiringRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryFactory;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;
import tools.descartes.prisma.core.templates.core.NamedElementTemplate;

public class InterfaceRequiringRoleTemplate extends NamedElementTemplate<InterfaceRequiringEntity, InterfaceRequiringRole> {

	private final InterfaceTemplate interfaceCmd;
	
	public InterfaceRequiringRoleTemplate(String portName, InterfaceTemplate addInterface) {
		this(Status.CREATE, portName, addInterface);
	}

	public InterfaceRequiringRoleTemplate(Status status, String portName, InterfaceTemplate addInterface) {
		super(status, RepositoryPackage.Literals.INTERFACE_REQUIRING_ENTITY__INTERFACE_REQUIRING_ROLES, InterfaceRequiringRole.class, portName);
		this.interfaceCmd = addInterface;
	}

	@Override
	public boolean matches(InterfaceRequiringRole object) {
		if (object == null) {
			return false;
		}
		return super.matches(object)
				&& interfaceCmd.matches(object.getInterface());
	}

	@Override
	protected InterfaceRequiringRole create(InterfaceRequiringEntity parent) {
		Interface interf = interfaceCmd.get(getContext().getRepository());
		InterfaceRequiringRole requiringRole = RepositoryFactory.eINSTANCE.createInterfaceRequiringRole();
		requiringRole.setName(getName());
		requiringRole.setInterface(interf);
		return requiringRole;
	}

}
