package tools.descartes.prisma.core.templates.repository;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.Interface;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.Repository;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryFactory;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;
import tools.descartes.prisma.core.templates.ModelTemplate;
import tools.descartes.prisma.core.templates.core.NamedElementTemplate;

public class InterfaceTemplate extends NamedElementTemplate<Repository, Interface> {

	private final Map<String, SignatureTemplate> signatures = new HashMap<>();
	
	public InterfaceTemplate(String interfaceName) {
		super(RepositoryPackage.Literals.REPOSITORY__INTERFACES, Interface.class, interfaceName);
	}

	@Override
	protected Interface create(Repository repository) {
		Interface curInterface = RepositoryFactory.eINSTANCE.createInterface();
		curInterface.setId("Interface_" + getId(getName()));
		curInterface.setName(getName());
		return curInterface;
	}
	
	@Override
	public List<? extends ModelTemplate<Interface, ?>> getChildCommands() {
		return new ArrayList<>(signatures.values());
	}

	public SignatureTemplate defineSignature(String signatureName) {
		SignatureTemplate template = signatures.get(signatureName);
		if (template == null) {
			template = new SignatureTemplate(signatureName);
			signatures.put(signatureName, template);
		}
		return template;
	}
}
