package tools.descartes.prisma.core.templates.resourceconfiguration;

import edu.kit.ipd.descartes.mm.resourceconfiguration.ActiveResourceSpecification;
import edu.kit.ipd.descartes.mm.resourceconfiguration.NumberOfParallelProcessingUnits;
import edu.kit.ipd.descartes.mm.resourceconfiguration.ProcessingResourceSpecification;
import edu.kit.ipd.descartes.mm.resourceconfiguration.ResourceconfigurationFactory;
import edu.kit.ipd.descartes.mm.resourceconfiguration.ResourceconfigurationPackage;
import edu.kit.ipd.descartes.mm.resourceconfiguration.SchedulingPolicy;
import tools.descartes.prisma.core.templates.core.NamedElementTemplate;
import tools.descartes.prisma.core.templates.resourcetype.ProcessingResourceTypeTemplate;

public class ProcessingResourceSpecificationTemplate extends NamedElementTemplate<ActiveResourceSpecification, ProcessingResourceSpecification> {
	
	private final ProcessingResourceTypeTemplate typeTemplate;
	private final SchedulingPolicy policy;
	private final int units;

	public ProcessingResourceSpecificationTemplate(String name, ProcessingResourceTypeTemplate typeTemplate, SchedulingPolicy policy, int units) {
		super(ResourceconfigurationPackage.Literals.ACTIVE_RESOURCE_SPECIFICATION__PROCESSING_RESOURCE_SPECIFICATIONS, ProcessingResourceSpecification.class, name);
		this.typeTemplate = typeTemplate;
		this.policy = policy;
		this.units = units;
	}

	@Override
	protected ProcessingResourceSpecification create(ActiveResourceSpecification parent) {
		ProcessingResourceSpecification res = ResourceconfigurationFactory.eINSTANCE.createProcessingResourceSpecification();
		res.setName(getName());
		res.setActiveResourceType(typeTemplate.get(getContext().getResourceTypeRepository()));
		res.setSchedulingPolicy(policy);
		NumberOfParallelProcessingUnits n = ResourceconfigurationFactory.eINSTANCE.createNumberOfParallelProcessingUnits();
		n.setName(getName());
		n.setNumber(units);
		res.setNrOfParProcUnits(n);
		return res;
	}

}
