package tools.descartes.prisma.core.templates.resourcelandscape;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

import edu.kit.ipd.descartes.mm.resourcelandscape.Container;
import tools.descartes.prisma.core.templates.ModelTemplate;
import tools.descartes.prisma.core.templates.core.NamedElementTemplate;
import tools.descartes.prisma.core.templates.resourceconfiguration.ActiveResourceSpecificationTemplate;

public abstract class ContainerTemplate<P extends EObject, E extends Container> extends NamedElementTemplate<P, E> {
	
	private final Map<String, ContainerTemplate<E, ?>> containedContainers = new HashMap<>();
	private final Map<String, ActiveResourceSpecificationTemplate> resources = new HashMap<>();
	
	public ContainerTemplate(EStructuralFeature container, Class<E> elementType, String name) {
		super(container, elementType, name);
	}
	
	@Override
	public List<? extends ModelTemplate<? super E, ?>> getChildCommands() {
		List<ModelTemplate<? super E, ?>> children = new ArrayList<>();
		children.addAll(containedContainers.values());
		children.addAll(resources.values());
		return children;
	}
	
	public ActiveResourceSpecificationTemplate defineActiveResource(String name) {
		ActiveResourceSpecificationTemplate template = resources.get(name);
		if (template == null) {
			template = new ActiveResourceSpecificationTemplate(name);
			resources.put(name, template);
		}
		return template;
	}

}
