package tools.descartes.prisma.core.templates.resourcelandscape;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import edu.kit.ipd.descartes.mm.resourcelandscape.DataCenter;
import edu.kit.ipd.descartes.mm.resourcelandscape.DistributedDataCenter;
import edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapeFactory;
import edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage;
import tools.descartes.prisma.core.templates.ModelTemplate;
import tools.descartes.prisma.core.templates.core.NamedElementTemplate;

public class DataCenterTemplate extends NamedElementTemplate<DistributedDataCenter, DataCenter> {
	
	private final Map<String, ComputingInfrastructureTemplate> computingInfrastructure = new HashMap<>();

	public DataCenterTemplate(String name) {
		super(ResourcelandscapePackage.Literals.DISTRIBUTED_DATA_CENTER__CONSISTS_OF, DataCenter.class, name);
	}
	
	public ComputingInfrastructureTemplate defineComputingInfrastructure(String name) {
		ComputingInfrastructureTemplate template = computingInfrastructure.get(name);
		if (template == null) {
			template = new ComputingInfrastructureTemplate(name);
			computingInfrastructure.put(name, template);
		}
		return template;
	}
	
	@Override
	public List<? extends ModelTemplate<? super DataCenter, ?>> getChildCommands() {
		return new ArrayList<>(computingInfrastructure.values());
	}

	@Override
	protected DataCenter create(DistributedDataCenter parent) {
		DataCenter dc = ResourcelandscapeFactory.eINSTANCE.createDataCenter();
		dc.setName(getName());
		return dc;
	}

}
