package tools.descartes.prisma.core.templates.servicebehavior;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.AbstractAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ComponentInternalBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorFactory;
import tools.descartes.prisma.core.templates.ModelTemplate;

public class ComponentInternalBehaviorTemplate<P extends EObject> extends ModelTemplate<P, ComponentInternalBehavior> {
	
	private final List<AbstractActionTemplate<? extends AbstractAction>> actionTemplates = new ArrayList<>();

	protected ComponentInternalBehaviorTemplate(EStructuralFeature container) {
		super(container, ComponentInternalBehavior.class);
	}
	
	@Override
	public List<AbstractActionTemplate<? extends AbstractAction>> getChildCommands() {
		return actionTemplates;
	}

	@Override
	public boolean matches(ComponentInternalBehavior object) {
		// The component internal behavior has no identity itself.
		return true;
	}
	
	@Override
	protected ComponentInternalBehavior create(P parent) {
		return ServicebehaviorFactory.eINSTANCE.createComponentInternalBehavior();
	}
	
	public List<AbstractActionTemplate<? extends AbstractAction>> getActions() {
		return actionTemplates;
	}
	
	public void add(AbstractActionTemplate<? extends AbstractAction> action) {
		if (!actionTemplates.isEmpty()) {
			action.setPredecessorAction(actionTemplates.get(actionTemplates.size() - 1));;
		}		
		actionTemplates.add(action);
	}

}
