package tools.descartes.prisma.parameterization;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Collections;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;

import tools.descartes.librede.Librede;
import tools.descartes.librede.configuration.ConfigurationFactory;
import tools.descartes.librede.configuration.EstimationAlgorithmConfiguration;
import tools.descartes.librede.configuration.EstimationApproachConfiguration;
import tools.descartes.librede.configuration.EstimationSpecification;
import tools.descartes.librede.configuration.LibredeConfiguration;
import tools.descartes.librede.configuration.ValidationSpecification;
import tools.descartes.librede.configuration.ValidatorConfiguration;
import tools.descartes.librede.registry.Registry;
import tools.descartes.librede.units.Time;
import tools.descartes.librede.units.UnitsFactory;
import tools.descartes.prisma.core.DmlInstance;

public class Main {
	public static void main(String[] args) throws IOException {
		Librede.init();
		
				
		
//		Path dataLocation = Paths.get("D:/Dateien/VMware/SPECjExperiments/Run_2015-04-11_16-04-55_Tx60");
//		Path modelLocation = Paths.get("C:/Users/Simon/Workspaces/specjent-model/specjent-model2/fullmodelsdl-loadbalancer");
//		DmlInstance inst = new DmlInstance(modelLocation, "testsystem");
//		
//		inst.load();
//		MappingModel mapping = new MappingModel();
//		
//		LibredeConfiguration conf = ConfigurationFactory.eINSTANCE.createLibredeConfiguration();
//		
//		WorkloadDescriptionDerivation workload = new WorkloadDescriptionDerivation();
//		conf.setWorkloadDescription(workload.deriveWorkloadDescription(inst.getDeployment(), mapping));
//		
//		InputSpecificationDerivationStrategy deriveInput = new InputSpecificationDerivationStrategy();
//		conf.setInput(deriveInput.deriveInputSpecification(conf.getWorkloadDescription(), dataLocation, mapping));
//		
//		EstimationSpecification estimation = ConfigurationFactory.eINSTANCE.createEstimationSpecification();
//		estimation.setRecursive(false);
//		estimation.setWindow(60);
//		estimation.setStepSize(UnitsFactory.eINSTANCE.createQuantity(1.0, Time.MINUTES));
//		
//		
//		//Tx60
//		estimation.setStartTimestamp(UnitsFactory.eINSTANCE.createQuantity(1.428756360E9, Time.SECONDS));
//		estimation.setEndTimestamp(UnitsFactory.eINSTANCE.createQuantity(1.428759960E9, Time.SECONDS));
//		
////		estimation.setStartTimestamp(UnitsFactory.eINSTANCE.createQuantity(1.438163220E9, Time.SECONDS));
////		estimation.setEndTimestamp(UnitsFactory.eINSTANCE.createQuantity(1.438167360E9, Time.SECONDS));
//		
//		//Tx100
//		//estimation.setStartTimestamp(UnitsFactory.eINSTANCE.createQuantity(1.429781887E9, Time.SECONDS));
//		//estimation.setEndTimestamp(UnitsFactory.eINSTANCE.createQuantity(1.429785487E9, Time.SECONDS));
//		
//		EstimationApproachConfiguration approach = ConfigurationFactory.eINSTANCE.createEstimationApproachConfiguration();
//		approach.setType("tools.descartes.librede.approach.ServiceDemandLawApproach");
//		estimation.getApproaches().add(approach);
//		
//		EstimationAlgorithmConfiguration algorithm = ConfigurationFactory.eINSTANCE.createEstimationAlgorithmConfiguration();
//		algorithm.setType("tools.descartes.librede.algorithm.SimpleApproximation");
//		estimation.getAlgorithms().add(algorithm);
//		conf.setEstimation(estimation);
//		
//		ValidationSpecification validation = ConfigurationFactory.eINSTANCE.createValidationSpecification();
//		validation.setValidateEstimates(true);
//		ValidatorConfiguration rVal = ConfigurationFactory.eINSTANCE.createValidatorConfiguration();
//		rVal.setType("tools.descartes.librede.validation.ResponseTimeValidator");
//		validation.getValidators().add(rVal);
//		ValidatorConfiguration uVal = ConfigurationFactory.eINSTANCE.createValidatorConfiguration();
//		uVal.setType("tools.descartes.librede.validation.UtilizationValidator");
//		validation.getValidators().add(uVal);
//		
//		conf.setValidation(validation);
//		
//		conf.setOutput(ConfigurationFactory.eINSTANCE.createOutputSpecification());
//		
//		Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put("librede", new XMIResourceFactoryImpl());
//		
//		ResourceSet rset = Registry.INSTANCE.createResourceSet();
//		Resource xmi = rset.createResource(URI.createFileURI(modelLocation.resolve("estimation.librede").toString()));
//		xmi.getContents().add(conf);
//		xmi.save(Collections.EMPTY_MAP);
//		
////		MemoryObservationRepository repo = new MemoryObservationRepository(conf.getWorkloadDescription());
////		repo.setCurrentTime(conf.getEstimation().getEndTimestamp());
////		Librede.loadRepository(conf, repo);
////
////		try {
////			List<ResultTable[]> results = Librede.runEstimation(conf, repo);
////			ResultTable table = results.get(0)[0];
////			
////			Vector state = table.getLastEstimates();
////			
////			Table<String, String, List<ResourceDemand>> demandMapping = workload.getDemandMapping();
////			
////			for (int i = 0; i < state.rows(); i++) {
////				double estimate = state.get(i);
////				tools.descartes.librede.configuration.Resource res = table.getResource(i);
////				Service service = table.getService(i);
////				List<ResourceDemand> demands = demandMapping.get(service.getName(), res.getName());
////				if (demands != null) {
////					for (ResourceDemand d : demands) {
////						d.setCharacterization(ModelVariableCharacterizationType.EXPLICIT);
////						RandomVariable var = d.getExplicitDescription();
////						if (var == null) {
////							var = FunctionsFactory.eINSTANCE.createRandomVariable();
////							d.setExplicitDescription(var);
////						}						
////						ExponentialDistribution expDist = FunctionsFactory.eINSTANCE.createExponentialDistribution();
////						if (estimate != 0) {
////							expDist.setRate(BigDecimal.valueOf(1 / estimate));
////						} else {
////							expDist.setRate(BigDecimal.ZERO);
////						}
////						var.setProbFunction(expDist);
////					}
////				}				
////			}
////		} catch (Exception e) {
////			e.printStackTrace();
////		}
////		
////		inst.storeTo(modelLocation.resolve("model"));
//		
//		System.out.println("T");
	}
	
	
}
